/**************************************************/
/*               Casio2.h  ver 2.01               */
/**************************************************/

/*        Casio Header/Lib - Na-Prod Casio Development Kit   2             */
/* All these routines works with Video Pages to work with Multi-Buffering  */ 
/*    Part of Na-Prod Casio Project & CDK & Graph100 French Network        */
/*  Thanks to Whyp, 2072, BradN, Y@SS, Bugbug, Libthium, Duobab, Roeoender */
/*  	New Pixel Routines by SUPERNA, 27% faster than old ones		   */
/*   New exclusives routines : Time, date, contrast, On/Off and Reboot !   */
/* 	See casio2.html for help and examples or www.na-prod.com	   */

/**************************************************/
/*                   Constantes                   */
/**************************************************/

#define DATA_SIZE 1024
#include <stdio.h>
#include <dos.h>
#include <string.h>

                  /* DEFINITIONS */
	typedef unsigned char BMPTabType [DATA_SIZE];
	void disp_bmp (BMPTabType BmpTab, int page);
	void rebootcalc();
	void shutcalc();
	unsigned char getkey();
	void wait(long t);
	void locate(int x,int y,char st[]);
	void waitakey(int k);
	int waitkey();
	void invpage(int page);
	void invRect(int x1,int y1,int x2,int y2,int page);
	void fillRect(int x1,int y1,int x2,int y2,int page,int state);
	void rect(int x1,int y1,int x2,int y2, int page, int state);
	void vline2(int y1, int y2, int x,int page , int state);
	void hline2(int x1, int x2, int y,int page , int state);
	void setpage(short page);
	int shootpage(short page);
	int getpage(void);
	void clearpage(short page);
	char tstpixel(int X, int Y, int page);
	void invpixel(int x, int y, int page);
	void (far * PtrReboot) (void);
            /* End DEFINITIONS */

		/* Keys definition de Waitkey() par Y@SS Correct 
			Ceux avec "*" sont compatible avec getkey()  */

#define K_F1		0x003B  // *
#define K_F2		0x003C  // *
#define K_F3		0x003D  // *
#define K_F4		0x003E  // *
#define K_F5		0x003F  // *
#define K_F6		0x0040  // *
#define K_SHIFT		0x002A  // *
#define K_CTRL		0x001D  // *
#define K_OPTN		0x003A  // *
#define K_GAUCHE	0x004B  // *
#define K_DROITE	0x004D  // *
#define K_HAUT		0x0048  // *
#define K_BAS		0x0050  // *
#define K_ALPHA		0x0038  // *
#define K_VARS		0x0046  // *
#define K_PUISS		0x005E
#define K_ESC		0x0001  // *
#define K_X		0x0041
#define K_LOG		0x0042
#define K_LN		0x0043  // *
#define K_SIN		0x0044  // *
#define K_COS		0x0045  // *
#define K_TAN		0x0046  // *
#define K_DC		0x0047  // *
#define K_X2		0x0048  // *
#define K_CRH_G		0x0049  // *
#define K_CRH_D		0x004A  // *
#define K_VIRG		0x004B  // *
#define K_FLECHE	0x004C  // *
#define	K_7		0x0037
#define	K_8		0x0038
#define	K_9		0x0039
#define K_DEL		0x0053  // *
#define K_ACon		0x0045
#define	K_4		0x0034
#define	K_5		0x0035
#define	K_6		0x0036
#define K_FOIS		0x0053
#define K_DIVIS		0x0054
#define	K_1		0x0031
#define	K_2		0x0032
#define	K_3		0x0033
#define K_PLUS		0x0058
#define K_MOINS		0x0059
#define	K_0		0x0030
#define K_POINT		0x002E
#define K_EXP		0x0052  // *
#define K_TIRET		0x000C  // *
#define K_EXE		0x001C  // *


/**************************************************/
/*                   Functions                    */
/**************************************************/
              /* Graphic Functions */

void setPix(short X,short Y,short page,unsigned char couleur){  // Met un pixel Whyp&Superna
asm {	
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63
	mov cx,127
	sub si,Y //On copie y   //4
	sub cx,X //On copie x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,couleur
	mov bl,es:[si] // Recupere le byte a changer
	db 0x0F,0x12,0x0C3      // clr1 bl,cl (specifique au nec v20/30)
	rol al,cl		// met le 1 (si 1) a la place voulue
	or bl,al		// Ecris le 1 (si 1)
	mov es:[si],bl };}	// Remet le byte

void setbPix(short x,short y,short page){ //Superna
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63
	mov cx,127
	sub si,y //On copie y   //4
	sub cx,x //On copie x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,1   //On met le state    //2
	shl ch,cl     //on le deplace selon cl //3
	or es:[si],ch}}; //On l'applique a l'octet //7// Remet le byte


void setwPix(int x,int y,int page){ //Superna
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //On copie y   //4
	mov cx,127 //On copie x   //4
	sub si,y //on enleve y
	sub cx,x //on enleve x
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,es:[si] //On prends l'octet //4
	mov bl,0x01  //On met 1 //2
	shl bl,cl    //On le deplace //3
	and bl,ch    //On prends le bit si il existe //2
	xor es:[si],bl}}; //On l'applique a l'octet //7

void invpixel(int x,int y,int page){
asm{
	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //on met 64
	mov cx,127 //on met 128
	sub si,y //On enleve y   //4
	sub cx,x //On enleve x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov ch,1   //On met le state    //2
	shl ch,cl     //on le deplace selon cl //3
	xor es:[si],ch}}; //On l'applique a l'octet //7

char tstpixel(int X, int Y,int page) { //Teste un pixel et retourne 0 ou 1//Superna&Whyp
asm {	mov cx,page  //numero de page   //4
	shl cx,6     //multiplication par 64 //2
	add cx,0x1a20  //ajout de la page 0  //2
	mov es,cx  //on le met dans es    //2
	mov si,63 //on met 64
	mov cx,127 //on met 128
	sub si,Y //On enleve y   //4
	sub cx,X //On enleve x   //4
	mov bx,cx //On en fait une copie  //2
	and cx,7 //Reste de division par 8 dans cl //2
	shr bx,3 //on divise par 8 //3
	shl bx,6 //On multiplie par 64  //2
	add si,bx //On ajoute le tout a si //1
	mov al,es:[si];
	ror al,cl;
	and al,1; }
return _AL; }

void clearpage(short page) { // Efface l'ecran Whyp
int i;
asm mov ax,page;
asm shl ax,6;
asm add ax,0x1A20;
asm mov es,ax;
asm xor ax,ax;
for (i=0;i<1024;i+=2){
	_SI=i;
	asm mov es:[si],ax; } } 

int getpage(void) { //Prens la page courante (Moi)
	short sEgMt=peek(0x4E,0); // Recupere le segment
	return ((sEgMt-0x1A20)/0x40);}


int shootpage(short page) {  // Y@SS Prends un Screenshot
unsigned int segm_video=0x1A20+(page*0x40);
unsigned long adresse; 
unsigned int found=0, b=0, i, offset, progseg, segment; 
unsigned char realname[6]; 
progseg=0x1A20 + 0x200; 
strcpy((unsigned char *)(realname), "HCOPY1"); 
for(segment=progseg; segment < (progseg + 10000); segment++) { 
	for (offset=0; offset < 16; offset++) { 
	if (((unsigned char)peekb(segment, offset)) == ((unsigned char)realname[b])) { 
		b++; 
		if (b==5) { 
			found=1; 
			break; } } 
	else { 
		if (b) { 
			b=0; 
			offset--; } } } 
	if(found) break; } 
	if (!found) { 
		return (-1); } 
b--; b--; 
b += 3; 
adresse=((unsigned long)segment) * 16 + offset; 
segment=((adresse ) - (adresse )%16 )/16; 
offset= (adresse )%16; 
offset+=3; 
for(b=0;b<=1024;b++) pokeb( segment , offset+b , peekb (segm_video, b)); 
return 1; }

void setpage(short page){  // Met la page voulue Libthium
	asm{
	mov ax,page
	shl ax,6
	add ax,0x1A20
	xor dx,dx
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	shl ax,1
	rcl dx,1
	out 0x05,ax
	mov al,dl
	out 0x07,al } }

void hline2(int x1, int x2, int y,int page , int state) //Dessine une ligne Horizontale Duobab
	{int i;for(i=x1; i<x2;i++) setPix(i,y,page,state) ;}
	
void vline2(int y1, int y2, int x,int page , int state) //Dessine une ligne Verticale Duobab
	{int i;for(i=y1; i<y2;i++) setPix(x,i,page,state) ;}
	
void rect(int x1,int y1,int x2,int y2, int page, int state) //Dessine un rectangle Duobab
	{hline2(x1,x2,y1,page,state);
	hline2(x1,x2,y2,page,state);
	vline2(y1,y2,x1,page,state);
	vline2(y1,y2,x2,page,state);}

void fillRect(int x1,int y1,int x2,int y2,int page,int state) //Rempli un rectangle Duobab
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			setPix(i,j,page,state);}

void invRect(int x1,int y1,int x2,int y2,int page) //Inverse un rectangle Moi
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			invpixel(i,j,page);}

void invpage(int page){	//Inverse l'ecran (2072) en mieux
int x,seg;
asm shl page,6;
asm add page,0x1a20;
seg=page;
for (x=0; x<0x200; x++)
poke(seg, x << 1, peek(seg, x << 1) ^ 0xFFFF);} 

void copypage(int source ,int target){asm{ //Copy la page source a la page target - Superna
	push ds
	mov ax,target
	shl ax,6
	add ax,0x1A20
	mov es,ax
	mov di,0
	mov ax,source
	shl ax,6
	add ax,0x1A20
	mov ds,ax
	mov si,0
	cld
	mov cx,512
	rep movsw
	pop ds};}


/************************* Utility Functions **************************/

int waitkey() //Attends une touche pressee et la retourne
	{int v=getch();
	if (v==0) v=getch();
	return v;}

void waitakey(int k)
	{int v;
	do{v=getch();if (v==0) v=getch();}
	while(v!=k);} 

void locate(int x,int y,char st[]){
	gotoxy(x,y);
	printf(st);}

void wait(long t){long i;
	for (i=0; i<=t*100;i++);}

unsigned char getkey() { // Y@SS
	return peekb(0x40,0xAF); }


void shutcalc(){ //Eteint la calculatrice Whyp
asm mov al,0x08;
asm out 0x0C,al;}

void rebootcalc(){  // Fait rebooter la calculatrice Bugbug&BradN
PtrReboot =(void * far) MK_FP(0xFFFF,0x0000);
(*PtrReboot) ();
}

// Contraste par WHYP

void contplus(){    //Plus fonce
asm{mov bl,0
mov ah,0x22
int 0x7C};};

void contless(){    //Plus Clair
asm{mov bl,1
mov ah,0x22
int 0x7C};};

//Retourne 1:Heure 2:Minute 2:Secondes par Niff
unsigned char get_time(unsigned char what){
if(what!=1&&what!=2&&what!=3) return 0;
asm {
xor ax,ax
mov dx,0x0020
mov al,what
sub dx,ax
in al,dx };
return _AL; } 

//Regle what:1=Heures 2=Minutes time:temps entre 0 et 59 (les secondes se mettent a 0)
unsigned char set_time(unsigned char what,unsigned char time){
if(what!=1&&what!=2) return 0;
if(time>59||time<0) return 0;
asm{
xor ax,ax
mov dx,0x0020
mov al,what
sub dx,ax
mov al,time
out dx,al
hlt
mov al,0x03
sub al,what
out 0x1D,al };
return 1; }

//Retourne la date
//what:0=[Jours] 1=[Mois] 2=[annee] 3=[njour]
//jours:0=[si de la caltos] sinon=[jours ecoules depuis le 1/1/2000]
//njour:0=Lundi -> 6=Dimanche
unsigned short get_date(unsigned char what, unsigned short jours){
	unsigned char mois[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	unsigned char nyear=0,byear=0,month=0,day=0;
if(jours==0){ asm in ax,0x20;jours=_AX;}
day=jours%7+5;if(day>6) day-=7;
if(what==3) return day;
if(jours>=366){
byear=(((jours-366)/365)/4)+1;
nyear=jours/365;}
if(what==2) return (2000+nyear);
if(nyear%4==0) mois[1]=29;
jours-=(nyear*365)+byear;
debct:
if(jours>=mois[month]){ jours-=mois[month];
	month++;
	goto debct; }
if(what==1) return (month+1);
return (jours+1); }

//Regle la date
//year:[2000;2158] month:[1;12] days:[0;31]
//Retourne le nombre de jours depuis 1/1/2000
unsigned short set_date(short year,char month,char days){
	unsigned char mois[12]={31,28,31,30,31,30,31,31,30,31,30,31};
	unsigned char byear=0;
	unsigned short total;
year-=2000;month--;days--;
byear=(year-1)/4;
if(year>0) byear++;
total=(year*365)+byear;
if(year%4==0) mois[1]=29;
for(byear=0;byear<month;byear++) total+=mois[byear];
if(days>mois[month]) total+=mois[month];
else total+=days;
_AX=total;
asm out 0x20,ax;
asm mov al,4;
asm out 0x1d,al;
return total;}


/**************************** BMP2C Routine ************************/

void disp_bmp (BMPTabType BmpTab,int page) { // Plus rapide Par Moi, Whyp et Roeoender
asm{ mov ax,page
     shl ax,6
     add ax,0x1a20
     mov es,ax
     mov si,offset BmpTab
     xor di,di
     mov cx,0x200
     cld
     rep movsw } }

/*******************************************************************/
/*  Na-Prod Casio Project 2002 - Na-Prod.fr.st                     */
/*******************************************************************/
/* To users of the casio.h header file :                           */
/* setPix(x,y,segmt,state)=setPix(x,y,PAGE,state)                  */
/* cls()=clearpage(PAGE)                                           */
/* hline2(x1,x2,y,segm,state)=hline2(x1,x2,y,PAGE,state)           */
/* vline2(y1,y2,x,segm,state)=vline2(y1,y2,x,PAGE,state)           */
/* rect(x1,y1,x2,y2,segm,state)=rect(x1,y1,x2,y2,PAGE,state)       */
/* fillRect(x1,y1,x2,y2,SEG,state)=fillRect(x1,y1,x2,y2,PAGE,state)*/
/* set_video_page(page)=setpage(page)                              */
/* To see changes between key definitions, see casio2.html file    */
/*******************************************************************/
