////////////////////////////////////////////////////////////////////////////////////////////////////
// SHIP BATTLE // VERSION 1.30 // BY PHCORP (c) PH CORPORATION // AN AFX TEAM PRODUCTION
////////////////////////////////////////////////////////////////////////////////////////////////////

// TYPES D UNITEES MOBILES
// 1 : AVION
// 2 : SOUS-MARIN
// 3 : BATEAU

// DOMMAGES
// 1: DOMMAGES AUX AMIS -> LE JOUEUR
// 2: DOMMAGES AUX ENNEMIS

// DIRECTION X SUPERIEURE A ZERO DONC SPRITES VERS LA DROITE
// DIRECTION X INFERIEURE A ZERO DONC SPRITES VERS LA GAUCHE

#include <stdlib.h>
#include <time.h>
#include <dos.h>
#include <mkeys.h>
#include "gxlib10.h"
#include "GxString.h"
#include "SPRITES.H"
#include "SCREENS.H"


////////////////////////////////////////////////////////////////////////////////////////////////////
// DEFINITION DES STRUCTURES
////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct projectile
{
	int position_x;
	int position_y;
	int direction_x;
	int direction_y;
	int dommages;
	struct projectile *p_projectile_precedent;
} projectile;

typedef struct unitee_mobile
{
	int position_x;
	int position_y;
	int direction_x;
	int direction_y;
	int type;
	struct unitee_mobile *p_unitee_mobile_precedent;
} unitee_mobile;

typedef struct unitee_amie
{
	int position_x;
	int position_y;
	int direction_x;
	int direction_y;
	int position;
	int type;
	int controle;
	int tirs;
	struct unitee_amie *p_unitee_amie_precedent;
} unitee_amie;

typedef struct nuages
{
	int position_x;
	int position_y;
	int direction_x;
	int direction_y;
	struct nuages *p_nuages_precedent;
} nuages;


////////////////////////////////////////////////////////////////////////////////////////////////////
// DECLARATION DES FONCTIONS
////////////////////////////////////////////////////////////////////////////////////////////////////

void affichage_de_la_mer ( int );
void affichage_des_nuages ( nuages * );
void affichage_des_projectiles ( projectile * );
void affichage_des_unitees_mobiles ( unitee_mobile * );
void affichage_des_unitees_amies ( unitee_amie * );

//--------------------------------------------------------------------------------------------------

void mouvement_des_nuages ( nuages ** );
void mouvement_des_projectiles ( projectile ** );
void mouvement_des_unitees_mobiles ( unitee_mobile ** );

//--------------------------------------------------------------------------------------------------

void creation_de_nuages ( nuages **, int, int, int, int );
void creation_de_projectile ( projectile **, int, int, int, int, int );
void creation_d_unitee_mobile ( unitee_mobile **, int, int, int, int, int );
void creation_d_unitee_amie ( unitee_amie **, int, int, int, int, int, int );
void apparition_de_tous_les_ennemis ( unitee_mobile ** );

//--------------------------------------------------------------------------------------------------

int detection_des_collisions_ennemis ( projectile **, unitee_mobile **, int );
int detection_des_collisions_amis ( projectile **, unitee_amie **, int );

//--------------------------------------------------------------------------------------------------

void ia_ennemis ( unitee_amie **, unitee_mobile **, projectile ** );
int tirs_amis_bas ( unitee_amie **, projectile **, int );
int tirs_amis_haut ( unitee_amie **, projectile **, int );

//--------------------------------------------------------------------------------------------------

void supprimer_amis ( unitee_amie ** );
void supprimer_ennemis ( unitee_mobile ** );
void supprimer_projectiles ( projectile ** );
void supprimer_nuages ( nuages ** );

//--------------------------------------------------------------------------------------------------

void wait ( long );

//--------------------------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////////////////////////
// DEFINITION DES FONCTIONS
////////////////////////////////////////////////////////////////////////////////////////////////////

void supprimer_amis ( unitee_amie **p )
{
	unitee_amie *victime;
	unitee_amie *ancien = NULL;
	unitee_amie *p1 = *p;
	while ( p1 )
	{
				if(ancien) ancien->p_unitee_amie_precedent = p1->p_unitee_amie_precedent;
				else *p = p1->p_unitee_amie_precedent;
				victime = p1;
				p1 = p1 -> p_unitee_amie_precedent;
				free ( victime );
	}	
}

void supprimer_ennemis ( unitee_mobile **p )
{
	unitee_mobile *victime;
	unitee_mobile *ancien = NULL;
	unitee_mobile *p1 = *p;
	while ( p1 )
	{
				if(ancien) ancien->p_unitee_mobile_precedent = p1->p_unitee_mobile_precedent;
				else *p = p1->p_unitee_mobile_precedent;
				victime = p1;
				p1 = p1 -> p_unitee_mobile_precedent;
				free ( victime );
	}	
}

void supprimer_projectiles ( projectile **p )
{
	projectile *victime;
	projectile *ancien = NULL;
	projectile *p1 = *p;
	while ( p1 )
	{
				if(ancien) ancien->p_projectile_precedent = p1->p_projectile_precedent;
				else *p = p1->p_projectile_precedent;
				victime = p1;
				p1 = p1 -> p_projectile_precedent;
				free ( victime );
	}	
}

void supprimer_nuages ( nuages **p )
{
	nuages *victime;
	nuages *ancien = NULL;
	nuages *p1 = *p;
	while ( p1 )
	{
				if(ancien) ancien->p_nuages_precedent = p1->p_nuages_precedent;
				else *p = p1->p_nuages_precedent;
				victime = p1;
				p1 = p1 -> p_nuages_precedent;
				free ( victime );
	}	
}

//--------------------------------------------------------------------------------------------------

void wait (long t)
{
	long i;
	for (i=0; i<=t*100;i++);
}

//--------------------------------------------------------------------------------------------------

void mouvement_des_nuages ( nuages **p )
{
	nuages *victime;
	nuages *ancien = NULL;
	nuages *p1 = *p;
	while ( p1 )
	{
		p1 -> position_x = p1 -> position_x + p1 -> direction_x;
		if ( p1 -> position_x > 128 )
		{
				if(ancien) ancien->p_nuages_precedent = p1->p_nuages_precedent;
				else *p = p1->p_nuages_precedent;
				victime = p1;
				p1 = p1 -> p_nuages_precedent;
				free ( victime );
		}
		else
		{
			ancien = p1;
			p1 = p1 -> p_nuages_precedent;
		}
	}	
}

void mouvement_des_unitees_mobiles ( unitee_mobile **p )
{
	unitee_mobile *victime;
	unitee_mobile *ancien = NULL;
	unitee_mobile *p1 = *p;
	while ( p1 )
	{
		p1 -> position_x = p1 -> position_x + p1 -> direction_x;
		if ( p1 -> position_x > 128 )
		{
				if(ancien) ancien->p_unitee_mobile_precedent = p1->p_unitee_mobile_precedent;
				else *p = p1->p_unitee_mobile_precedent;
				victime = p1;
				p1 = p1 -> p_unitee_mobile_precedent;
				free ( victime );
		}
		else if ( p1 -> position_x < -16 )
		{
				if(ancien) ancien->p_unitee_mobile_precedent = p1->p_unitee_mobile_precedent;
				else *p = p1->p_unitee_mobile_precedent;
				victime = p1;
				p1 = p1 -> p_unitee_mobile_precedent;
				free ( victime );
		}
		else
		{
			ancien = p1;
			p1 = p1 -> p_unitee_mobile_precedent;
		}
	}	
}

void mouvement_des_unitees_amies ( unitee_amie *p )
{
	while ( p )
	{
		if ( thetouche ( 9, 1 ) == 1 ) p -> direction_x = p -> direction_x - 1;
		if ( thetouche ( 9, 2 ) == 1 ) p -> direction_x = 0;
		if ( thetouche ( 9, 3 ) == 1 ) p -> direction_x = 0;
		if ( thetouche ( 9, 4 ) == 1 ) p -> direction_x = p -> direction_x + 1;
		if ( p -> direction_x < -2 ) p -> direction_x = -2;
		if ( p -> direction_x > 2 ) p -> direction_x = 2;
		if ( p -> direction_x < 0 ) p -> position = 0;
		if ( p -> direction_x > 0 ) p -> position = 1;
		p -> position_x = p -> position_x + p -> direction_x;
		if ( p -> position_x < -8 ) p -> position_x = -8;
		if ( p -> position_x > 120 ) p -> position_x = 120;
		p = p -> p_unitee_amie_precedent;
	}
}

//--------------------------------------------------------------------------------------------------

void ia_ennemis ( unitee_amie **p12, unitee_mobile **p22 , projectile **pile_projectile )
{
    unitee_amie *p11 = *p12;
    unitee_mobile *p21 = *p22;

    while ( p11 )
    {
	while ( p21 )
	{
	    // SI L AVION EST AU DESSUS DU BATEAU
	    if ( ( p21 -> position_x ==p11 -> position_x ) && ( p21 -> type == 1 ) )
	    {
		creation_de_projectile ( pile_projectile, ( p21 -> position_x + 8 ), p21 -> position_y, 0, 1, 1 );
	    }
	    // SI LE SOUS MARIN EST EN DESSOUS DU BATEAU
	    else if ( ( p21 -> position_x == p11 -> position_x ) && ( p21 -> type == 2 ) )
	    {
		creation_de_projectile ( pile_projectile, ( p21 -> position_x + 8 ), p21 -> position_y, 0, -1, 1 );
	    }
	    p21 = p21 -> p_unitee_mobile_precedent;
	}
	p11 = p11 -> p_unitee_amie_precedent;
    }

}

int tirs_amis_haut ( unitee_amie **p2, projectile **pile_projectile, int tirshaut )
{
	unitee_amie *p1 = *p2;

	while ( p1 )
	{
		// SI LA TOUCHE [f1] EST PRESSEE
		if ( ( thetouche ( 10, 1 ) == 1 ) && ( p1 -> position == 1 ) && ( tirshaut == 0 ) )
		{
		creation_de_projectile ( pile_projectile, ( p1 -> position_x + 8 ), p1 -> position_y, ( 1 + p1 -> direction_x ), ( -1 + p1 -> direction_y ), 2 );
		tirshaut = 10;
		}
		else if ( ( thetouche ( 10, 1 ) == 1 ) && ( p1 -> position == 0 ) && ( tirshaut == 0 ) )
		{
		creation_de_projectile ( pile_projectile, ( p1 -> position_x + 8 ), p1 -> position_y, ( -1 + p1 -> direction_x ), ( -1 + p1 -> direction_y ), 2 );
		tirshaut = 10;
		}
		p1 = p1 -> p_unitee_amie_precedent;
	}

	return ( tirshaut );

}
int tirs_amis_bas ( unitee_amie **p2, projectile **pile_projectile, int tirsbas )
{
	unitee_amie *p1 = *p2;

	while ( p1 )
	{
		// SI LA TOUCHE [f2] EST PRESSEE
		if ( ( thetouche ( 10, 2 ) == 1 ) && ( p1 -> position == 1 ) && ( tirsbas == 0 ) )
		{
		creation_de_projectile ( pile_projectile, ( p1 -> position_x + 8 ), p1 -> position_y, ( 0 + p1 -> direction_x ), ( 1 + p1 -> direction_y ), 2 );
		tirsbas = 10;
		}
		else if ( ( thetouche ( 10, 2 ) == 1 ) && ( p1 -> position == 0 ) && ( tirsbas == 0 ) )
		{
		creation_de_projectile ( pile_projectile, ( p1 -> position_x + 8 ), p1 -> position_y, ( 0 + p1 -> direction_x ), ( 1 + p1 -> direction_y ), 2 );
		tirsbas = 10;
		}
		p1 = p1 -> p_unitee_amie_precedent;
	}

	return ( tirsbas );

}

//--------------------------------------------------------------------------------------------------

void mouvement_des_projectiles ( projectile **p )
{
	projectile *victime;
	projectile *ancien = NULL;
	projectile *p1 = *p;
	while ( p1 )
	{
		p1 -> position_x = p1 -> position_x + p1 -> direction_x;
		p1 -> position_y = p1 -> position_y + p1 -> direction_y;
		if ( ( p1 -> position_x > 128 ) || ( p1 -> position_x < 0 ) || ( p1 -> position_y > 64 ) || ( p1 -> position_y < 0 ) )
		{
				if(ancien) ancien->p_projectile_precedent = p1->p_projectile_precedent;
				else *p = p1->p_projectile_precedent;
				victime = p1;
				p1 = p1 -> p_projectile_precedent;
				free ( victime );
		}
		else
		{
			ancien = p1;
			p1 = p1 -> p_projectile_precedent;
		}
	}

}

//--------------------------------------------------------------------------------------------------

void affichage_des_projectiles ( projectile *p )
{
	while ( p )
	{
		gxSpr_M_C ( p -> position_x, p -> position_y, rocket );
		p = p -> p_projectile_precedent;
	}
}

void affichage_des_unitees_mobiles ( unitee_mobile *p )
{
	while ( p )
	{
		if ( ( p -> direction_x > 0 ) && ( p -> type == 1 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, jet1 );
		}
		else if ( ( p -> direction_x <= 0 ) && ( p -> type == 1 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, jet2 );
		}
		else if ( ( p -> direction_x > 0 ) && ( p -> type == 2 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, sub1 );
		}
		else if ( ( p -> direction_x <= 0 ) && ( p -> type == 2 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, sub2 );
		}
		else if ( ( p -> direction_x > 0 ) && ( p -> type == 3 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, ship1 );
		}
		else if ( ( p -> direction_x <= 0 ) && ( p -> type == 3 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, ship2 );
		}
		p = p -> p_unitee_mobile_precedent;
	}
}

void affichage_des_unitees_amies ( unitee_amie *p )
{
	while ( p )
	{
		if ( ( p -> position == 1 ) && ( p -> type == 1 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, jet1 );
		}
		else if ( ( p -> position == 0 ) && ( p -> type == 1 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, jet2 );
		}
		else if ( ( p -> position == 1 ) && ( p -> type == 2 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, sub1 );
		}
		else if ( ( p -> position == 0 ) && ( p -> type == 2 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, sub2 );
		}
		else if ( ( p -> position == 1 ) && ( p -> type == 3 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, ship1 );
		}
		else if ( ( p -> position == 0 ) && ( p -> type == 3 ) )
		{
			gxSpr_M_C ( p -> position_x, p -> position_y, ship2 );
		}
		p = p -> p_unitee_amie_precedent;
	}
}

void affichage_des_nuages ( nuages *p )
{
	while ( p )
	{
		gxSpr_M_C ( p -> position_x, p -> position_y, nuage );
		p = p -> p_nuages_precedent;
	}
}

void affichage_de_la_mer ( int itteration )
{
	int x;
	for ( x = 0; x <= 128; x = x + 4 )
	{
		gxSpr_M_C ( x, 32, sea[itteration] );
	}
}

//--------------------------------------------------------------------------------------------------

void creation_d_unitee_mobile ( unitee_mobile **p, int position_x_def, int position_y_def, int direction_x_def, int direction_y_def, int type_def )
{
	unitee_mobile *element;
	element=( unitee_mobile *) malloc ( sizeof ( unitee_mobile ) );
	// SI L ALLOCATION A ECHOUEE
	if ( !element ) exit ( 1 );
	element -> position_x = position_x_def;
	element -> position_y = position_y_def;
	element -> direction_x = direction_x_def;
	element -> direction_y = direction_y_def;
	element -> type = type_def;
	element -> p_unitee_mobile_precedent = *p;
	// LE POINTEUR POINTE SUR LE DERNIER ELEMENT
	*p = element;
}

void creation_d_unitee_amie ( unitee_amie **p, int position_x_def, int position_y_def, int direction_x_def, int direction_y_def, int type_def, int controle_def )
{
	unitee_amie *element;
	element=( unitee_amie *) malloc ( sizeof ( unitee_amie ) );
	// SI L ALLOCATION A ECHOUEE
	if ( !element ) exit ( 1 );
	element -> position_x = position_x_def;
	element -> position_y = position_y_def;
	element -> direction_x = direction_x_def;
	element -> direction_y = direction_y_def;
	element -> type = type_def;
	element -> controle = controle_def;
	element -> p_unitee_amie_precedent = *p;
	element -> position = 0;
	element -> tirs = 0;
	// LE POINTEUR POINTE SUR LE DERNIER ELEMENT
	*p = element;
}

void creation_de_projectile ( projectile **p, int position_x_def, int position_y_def, int direction_x_def, int direction_y_def, int dommages_def )
{
	projectile *element;
	element=( projectile *) malloc ( sizeof ( projectile ) );
	// SI L ALLOCATION A ECHOUEE
	if ( !element ) exit ( 1 );
	element -> position_x = position_x_def;
	element -> position_y = position_y_def;
	element -> direction_x = direction_x_def;
	element -> direction_y = direction_y_def;
	element -> dommages = dommages_def;
	element -> p_projectile_precedent = *p;
	// LE POINTEUR POINTE SUR LE DERNIER ELEMENT
	*p = element;
}

void creation_de_nuages ( nuages **p, int position_x_def, int position_y_def, int direction_x_def, int direction_y_def )
{
	nuages *element;
	element=( nuages *) malloc ( sizeof ( nuages ) );
	// SI L ALLOCATION A ECHOUEE
	if ( !element ) exit ( 1 );
	element -> position_x = position_x_def;
	element -> position_y = position_y_def;
	element -> direction_x = direction_x_def;
	element -> direction_y = direction_y_def;
	element -> p_nuages_precedent = *p;
	// LE POINTEUR POINTE SUR LE DERNIER ELEMENT
	*p = element;
}

//--------------------------------------------------------------------------------------------------

int detection_des_collisions_ennemis ( projectile **p12, unitee_mobile **p22, int score )
{
	projectile *victime_projectile;
	projectile *ancien_projectile = NULL;
	projectile *p11 = *p12;
	unitee_mobile *victime_unitee_mobile;
	unitee_mobile *ancien_unitee_mobile = NULL;
	unitee_mobile *p21 = *p22;
	int supprimer = 0;

	while ( p11 )
	{
		ancien_unitee_mobile = NULL;
		p21 = *p22;

		while ( p21 )
		{
			if ( ( p11 -> position_x >= p21 -> position_x ) && ( p11 -> position_x < ( p21 -> position_x + 16 ) ) && ( p11 -> position_y >= p21 -> position_y ) && ( p11 -> position_y < ( p21 -> position_y + 6 ) ) && ( p11 -> dommages == 2 ) )
			{
				// SUPPRESSION DE L UNITEE MOBILE
				if ( ancien_unitee_mobile ) ancien_unitee_mobile -> p_unitee_mobile_precedent = p21 ->p_unitee_mobile_precedent;
				else *p22 = p21 -> p_unitee_mobile_precedent;
				victime_unitee_mobile = p21;
				p21 = p21 -> p_unitee_mobile_precedent;
				free ( victime_unitee_mobile );
				supprimer = 1;
				score++;
			}
			else
			{
			ancien_unitee_mobile = p21;
			p21 = p21 -> p_unitee_mobile_precedent;
			}
		}
		if ( supprimer == 1 ) {
			// SUPPRESSION DU PROJECTILE
			if ( ancien_projectile ) ancien_projectile -> p_projectile_precedent = p11 ->p_projectile_precedent;
			else *p12 = p11 -> p_projectile_precedent;
			victime_projectile = p11;
			p11 = p11 -> p_projectile_precedent;
			free ( victime_projectile );
			supprimer = 0;
		}
		else
		{
		ancien_projectile = p11;
		p11 = p11 -> p_projectile_precedent;
		}
	}
	return ( score );
}

int detection_des_collisions_amis ( projectile **p12, unitee_amie **p22, int energie )
{
	projectile *victime_projectile;
	projectile *ancien_projectile = NULL;
	projectile *p11 = *p12;
	unitee_amie *p21 = *p22;
	int supprimer = 0;

	while ( p11 )
	{
		p21 = *p22;
		
		while ( p21 )
		{
			if ( ( p11 -> position_x >= p21 -> position_x ) && ( p11 -> position_x < ( p21 -> position_x + 16 ) ) && ( p11 -> position_y >= p21 -> position_y ) && ( p11 -> position_y < ( p21 -> position_y + 6 ) ) && ( p11 -> dommages == 1 ) )
			{
				// ENERGIE DIMINUE
				energie = energie - 1;
				supprimer = 1;
			}
			p21 = p21 -> p_unitee_amie_precedent;
		}
		if ( supprimer == 1 ) {
			// SUPPRESSION DU PROJECTILE
			if ( ancien_projectile ) ancien_projectile -> p_projectile_precedent = p11 ->p_projectile_precedent;
			else *p12 = p11 -> p_projectile_precedent;
			victime_projectile = p11;
			p11 = p11 -> p_projectile_precedent;
			free ( victime_projectile );
			supprimer = 0;
		}
		else
		{
		ancien_projectile = p11;
		p11 = p11 -> p_projectile_precedent;
		}
	}
	return ( energie );
}

//--------------------------------------------------------------------------------------------------

void apparition_de_tous_les_ennemis ( unitee_mobile **pile_unitee_mobile )
{

	// VARIABLES D INITIALISATION DES ENNEMIS
	int position_x_def, position_y_def, direction_x_def, direction_y_def, type_def;

	// INITIALISATION DE L ENNEMI

	// DEFINITION DE LA DIRECTION VERTICALE
	direction_y_def = 0;

	// DEFINITION DU COTE DE L ECRAN D OU RENTRE L ENNEMI
	direction_x_def = ( unsigned int ) rand (); 
	direction_x_def = ( direction_x_def % 4 ) - 1;
	if ( direction_x_def > 0 )
	{
		position_x_def = - 16;
	}
	else if ( direction_x_def == 0 )
	{
		direction_x_def = -2;
		position_x_def = 128;
	}
	else if ( direction_x_def < 0 )
	{
		position_x_def = 128;
	}
	// DEFINITION DU TYPE D ENNEMI
	type_def = ( unsigned int ) rand ();
	type_def = ( type_def % 2 ) + 1;
	// SI L ENNEMI EST UN AVION
	if ( type_def == 1 ){
		position_y_def = ( unsigned int ) rand (); 
		position_y_def = ( position_y_def % 12 );
	}

	// SI L ENNEMI EST UN SOUS MARIN
	if ( type_def == 2 ){
		position_y_def = ( unsigned int ) rand (); 
		position_y_def = ( position_y_def % 12 ) + 44;
	}
	// CREATION DE L ENNEMI
	creation_d_unitee_mobile ( pile_unitee_mobile, position_x_def, position_y_def, direction_x_def, direction_y_def, type_def );

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// FONCTION PRINCIPALE
////////////////////////////////////////////////////////////////////////////////////////////////////

int main ()
{
	// DECLARATION DES VARIABLES
	int score, boucle, iteration_par_4, iteration_par_10, iteration_par_20, iteration_par_20_max, energie, vitesse, tirshaut, tirsbas, x, y;
	// VARIABLES D INITIALISATION DES ENNEMIS
	int position_y_def, direction_x_def;
	// INITIALISATION DES PILES
	projectile *pile_projectile = NULL;
	unitee_mobile *pile_unitee_mobile = NULL;
	unitee_amie *pile_unitee_amie = NULL;
	nuages *pile_nuages = NULL;
	// INITIALISATION DE SRAND
	srand ( ( unsigned ) time ( NULL ) );

	// DEFINITION DES PARAMETRES D AFFICHAGE
	gxSetMode ( true );
	
	// EFFACER LE BUFFER VIDEO
	gxClearBuff ();

	// CHARGEMENT DE L ECRAN DE DEMARRAGE
	gxDrawBmp ( splashscreen );

	// RAFRAICHISSEMENT DE L ECRAN AVEC LE BUFFER VIDEO
	gxRefresh ();

	// ATTENTE DE L APPUI SUR UNE TOUCHE
	wait ( 1000 );
	getch ();

while ( 1 )
{

	// INITIALISATION DES VARIABLES
	score = 0;
	boucle = 1;
	iteration_par_4 = 0;
	iteration_par_10 = 0;
	iteration_par_20 = 0;
	iteration_par_20_max = 20;
	energie = 10;
	vitesse = 0;
	tirshaut = 0;
	tirsbas = 0;
	x = 0;
	y = 0;

	// EFFACER LE BUFFER VIDEO
	gxClearBuff ();

	//--------------------------------------------------------------------------------------------------

	// MENU

	while ( boucle == 1 )
	{

		// CHARGEMENT DU MENU
		gxDrawBmp ( menu );

		if ( ( x == 0 ) )
		{
			write(53, 53, "PLAY");

			if ( thetouche ( 1, 5 ) == 1 )
			{
				boucle=0;
			}
		}

		if ( ( x == 1 ) && ( y == 1 ) )
		{
			write(30, 53, "SPEED: FAST");
			vitesse = 0;
		}
		else if ( ( x == 1 ) && ( y == 0 ) )
		{
			write(30, 53, "SPEED: NORMAL");
			vitesse = 5;
		}
		else if ( ( x == 1 ) && ( y == 2 ) )
		{
			write(30, 53, "SPEED: LOW");
			vitesse = 10;
		}

		if ( ( x == 2 ) && ( y == 2 ) )
		{
			write(30, 53, "LEVEL: EASY");
			iteration_par_20_max = 30;
		}
		else if ( ( x == 2 ) && ( y == 0 ) )
		{
			write(30, 53, "LEVEL: MEDIUM");
			iteration_par_20_max = 20;
		}
		else if ( ( x == 2 ) && ( y == 1 ) )
		{
			write(30, 53, "LEVEL: HARD");
			iteration_par_20_max = 10;
		}


		if ( ( x == 3 ) )
		{
			write(53, 53, "QUIT");

			if ( thetouche ( 1, 5 ) == 1 )
			{
				gxSetMode ( false );
				return ( 0 );
			}
		}

		// RAFRAICHISSEMENT DE L ECRAN AVEC LE BUFFER VIDEO
		gxRefresh ();
		
		if ( thetouche ( 9, 1 ) == 1 )
		{
			x--;
			y = 0;
		}
		if ( thetouche ( 9, 4 ) == 1 )
		{
			x++;
			y = 0;
		}
		if ( thetouche ( 9, 2 ) == 1 ) y--;
		if ( thetouche ( 9, 3 ) == 1 ) y++;

		if ( y > 2 ) y = 0;
		if ( x > 3 ) x = 0;
		if ( y < 0 ) y = 2;
		if ( x < 0 ) x = 3;

		wait ( 100 );

	}
	boucle=1;

	//--------------------------------------------------------------------------------------------------

	// INITIALISATION DU JEU

	// CREATION DU BATEAU
	creation_d_unitee_amie ( &pile_unitee_amie, 56, 28, 0, 0, 3, 1 );

	// INITIALISATION DE L ENNEMI
	apparition_de_tous_les_ennemis ( &pile_unitee_mobile );

	//--------------------------------------------------------------------------------------------------

	// BOUCLE PRINCIPALE DU JEU
	while ( boucle == 1 )
	{
		// INCREMENTATION DES VARIABLES SERVANT A L ANIMATION DU FOND , A L APPARITION DES ENNEMIS ET DES NUAGES ET RAZ

		// ANIMATION DE LA MER
		iteration_par_4++;
		if ( iteration_par_4 == 4 )
		{
			iteration_par_4 = 0;
		}

		// APPARITION DES NUAGES
		iteration_par_10++;
		if ( iteration_par_10 == 10 )
		{
			direction_x_def = ( unsigned int ) rand (); 
			direction_x_def = ( direction_x_def % 2 ) + 1;
			position_y_def = ( unsigned int ) rand (); 
			position_y_def = ( position_y_def % 20 ) - 4;
			creation_de_nuages ( &pile_nuages, -16, position_y_def, direction_x_def, 0 );
			iteration_par_10 = 0;
		}

		// APPARITION DES ENNEMIS
		iteration_par_20++;
		if ( iteration_par_20 == iteration_par_20_max )
		{
			apparition_de_tous_les_ennemis ( &pile_unitee_mobile );
			iteration_par_20 = 0;
		}

		//--------------------------------------------------------------------------------------------------

		// EFFACER LE BUFFER VIDEO
		gxClearBuff ();

		// AFFICHE LE DECOR
		gxDrawBmp ( background );

		// AFFICHE LA MER
		affichage_de_la_mer ( iteration_par_4 );

		// AFFICHE LES NUAGES
		affichage_des_nuages ( pile_nuages );
		mouvement_des_nuages ( &pile_nuages );

		// AFFICHE LES UNITES MOBILES
		affichage_des_unitees_mobiles ( pile_unitee_mobile );
		mouvement_des_unitees_mobiles ( &pile_unitee_mobile );
		ia_ennemis ( &pile_unitee_amie, &pile_unitee_mobile, &pile_projectile );

		// AFFICHE LES UNITES AMIES
		affichage_des_unitees_amies ( pile_unitee_amie );
		mouvement_des_unitees_amies ( pile_unitee_amie );
		tirsbas = tirs_amis_bas ( &pile_unitee_amie, &pile_projectile, tirsbas );
		tirshaut = tirs_amis_haut ( &pile_unitee_amie, &pile_projectile, tirshaut );
		tirsbas--;
		if ( tirsbas < 0 ) tirsbas = 0;
		tirshaut--;
		if ( tirshaut < 0 ) tirshaut = 0;

		//AFFICHE LES PROJECTILES
		affichage_des_projectiles ( pile_projectile );
		mouvement_des_projectiles ( &pile_projectile );

		// DETECTE LES COLLISIONS
		score = detection_des_collisions_ennemis ( &pile_projectile, &pile_unitee_mobile, score );
		energie = detection_des_collisions_amis ( &pile_projectile, &pile_unitee_amie, energie );
		if ( energie <= 0 ) boucle = 0;

		// RALENTIT LE PROGRAMME
		wait ( vitesse );
		if ( thetouche ( 2, 4 ) == 1 ) vitesse--;
		if ( thetouche ( 2, 5 ) == 1 ) vitesse++;
		if ( vitesse < 0 ) vitesse = 0;

		// SORTIR DU PROGRAMME
		if ( thetouche ( 7, 4 ) == 1 ) boucle = 0;

		// AFFICHE LE SCORE
		write(1, 58, "SCORE:");
		writevalue(30,58,score);

		// AFFICHE LA VIE
		write(80, 58, "LIFE:   %");
		writevalue(104,58, ( energie * 10 ) );

		// RAFRAICHISSEMENT DE L ECRAN AVEC LE BUFFER VIDEO
		gxRefresh ();
	}

	//--------------------------------------------------------------------------------------------------

	// EFFACER LE BUFFER VIDEO
	gxClearBuff ();

	// CHARGEMENT DE L ECRAN DE FIN
	gxDrawBmp ( lostscreen );

	// RAFRAICHISSEMENT DE L ECRAN AVEC LE BUFFER VIDEO
	gxRefresh ();

	// ATTENTE DE L APPUI SUR UNE TOUCHE
	wait ( 1000);
	getch ();

	// EFFACER LE BUFFER VIDEO
	gxClearBuff ();

	// AFFICHE LE SCORE
	write(1, 1, "SCORE:");
	writevalue(31, 1,score);

	// RAFRAICHISSEMENT DE L ECRAN AVEC LE BUFFER VIDEO
	gxRefresh ();

	// ATTENTE DE L APPUI SUR UNE TOUCHE
	wait ( 1000 );
	getch ();

	// RAZ DES PILES
	supprimer_amis ( &pile_unitee_amie );
	supprimer_ennemis ( &pile_unitee_mobile );
	supprimer_projectiles ( &pile_projectile );
	supprimer_nuages ( &pile_nuages );

}

	// QUITTE LE PROGRAMME RETOUR AU MENU DE LA CALCULATRICE
	return ( 0 );
}